Attribute VB_Name = "fopen"
' Open File menu item was clicked
Sub fopensub()

'Dim retval
'Dim OpenFileName As String
'    On Error Resume Next
'    ' Set the commom dialog properties we need
'    frmRidimensiona_Img.CommonDialog1.filename = ""
'    ' We will load BMP, JPG, and TIF files
'    frmRidimensiona_Img.CommonDialog1.Filter = "Image Files |*.bmp;*.gif;*.jpg;*.png;*.tif|All files |*.*"
'    ' Display common dialog box
'    frmRidimensiona_Img.CommonDialog1.ShowOpen
'    If Err <> 32755 Then    ' User chose OK
'        ' Store selected filename in OpenFileName
'        OpenFileName = frmRidimensiona_Img.CommonDialog1.filename
'        ' Load the file
'        OpenFile (OpenFileName)
'    End If

End Sub

' Open the file
Private Sub OpenFile(filename As String)

Dim bdata As BITMAPINFOHEADER
Dim gdata As GifData
Dim jdata As JpegData
Dim tdata As TiffData
Dim pdata As PngData
Dim rcode As Long, j As Long, ftype As Long
Dim width As Long, length As Long, vbitcount As Long
Dim fileType As String
Dim newimage As imgdes
Dim tempimage As imgdes
Dim key As Long
Dim xres As Long
Dim yres As Long
Dim resunit As Long

    key = 1234567  ' Not the real key. Real key requires lzw license from Unisys

    On Error Resume Next
    Screen.MousePointer = 11   ' Change mouse pointer to hourglass

    ' Initialize variables
    rcode = BAD_FTPE
    ftype = 0
    ' Identify file type and get information about the file to load
    fileType = LCase$(right$(filename, 3))
    
    Select Case fileType
        
        Case "bmp"
            rcode = bmpinfo(filename, bdata)
            width = bdata.biWidth
            length = bdata.biHeight
            vbitcount = bdata.biBitCount
            
            rcode = allocimage(tempimage, width, length, vbitcount)
            If (rcode = NO_ERROR) Then
                rcode = loadbmp(filename, tempimage)
            End If
            
        Case "gif"
            unlockLZW (key)
            rcode = gifinfo(filename, gdata)
            width = gdata.width
            length = gdata.length
            vbitcount = gdata.vbitcount
                            
            rcode = allocimage(tempimage, width, length, vbitcount)
            If (rcode = NO_ERROR) Then
                rcode = loadgif(filename, tempimage)
            End If
            
        Case "jpg"
            rcode = jpeginfo(filename, jdata)
            width = jdata.width
            length = jdata.length
            vbitcount = jdata.vbitcount
            
            rcode = allocimage(tempimage, width, length, vbitcount)
            If (rcode = NO_ERROR) Then
                rcode = loadjpg(filename, tempimage)
            End If
        
        Case "png"
            rcode = pnginfo(filename, pdata)
            width = pdata.width
            length = pdata.length
            vbitcount = pdata.vbitcount
        
            rcode = allocimage(tempimage, width, length, vbitcount)
            If (rcode = NO_ERROR) Then
                rcode = loadpng(filename, tempimage)
            End If
        
        Case "tif"
            Dim totalpages As Long
            Dim arrayelems As Long
            Dim pageIndex As Long
                     
            ftype = 3
            rcode = tiffgetpageinfo(filename, totalpages, 0, arrayelems)
            pageIndex = 0   ' get info about the first page
        
            rcode = tiffinfopagebyindex(filename, tdata, pageIndex)
            rcode = tiffgetxyresolutionpagebyindex(filename, xres, yres, resunit, pageIndex)
            width = tdata.width
            length = tdata.length
            vbitcount = tdata.vbitcount
    
            rcode = allocimage(tempimage, width, length, vbitcount)
            If (rcode = NO_ERROR) Then
                rcode = loadtifpagebyindex(filename, tempimage, pageIndex)
                
                ' 16-bit grayscale
                If rcode = NO_ERROR And tdata.BitsPSample = 16 And tdata.SamplesPPixel = 1 Then
                   rcode = allocimage(newimage, width, length, 8)
                   rcode = convertgray16to8(tempimage, newimage)
                   freeimage tempimage
                   copyimgdes newimage, tempimage
                End If
            End If
    End Select
            
    If rcode = NO_ERROR Then
        
        ' Replace previous image
        freeimage vimage
        copyimgdes tempimage, vimage
        
        ' Display the new image
        frmRidimensiona_Img.Picture1 = image_to_picturebox(vimage)
        frmRidimensiona_Img.Picture1.Refresh

    End If
    
    Screen.MousePointer = 0   ' Reset the mouse pointer.

    ' Handle any errors
    If rcode <> NO_ERROR Then
        'frmRidimensiona_Img.error_handler rcode, filename
        error_handler rcode, filename
    End If
End Sub

' Save File menu item was clicked
Public Sub fsavesub()

'    Dim filename As String
'    On Error Resume Next
'
'    ' Set the commom dialog properties we need
'    frmRidimensiona_Img.CommonDialog1.filename = filename
'    ' Set filter string for BMP, JPG, and TIF
'    frmRidimensiona_Img.CommonDialog1.Filter = "BMP|*.bmp|GIF|*.gif|JPG|*.jpg|PNG|*.png|TIF|*.tif"
'    ' Display SaveAs dialog box
'    frmRidimensiona_Img.CommonDialog1.ShowSave
'    ' If the user chooses Cancel, set Filename to an empty string
'    If Err <> 32755 Then    ' User chose OK
'        filename = frmRidimensiona_Img.CommonDialog1.filename
'    Else
'        filename = ""
'    End If
'
'    ' Call save procedure. If Filename = "", user selected Cancel
'    If filename <> "" Then
'       ' Save the file
'       SaveFileAs filename
'    End If

End Sub

' Save the file
Public Sub SaveFileAs(filename As String)

Dim rcode As Long
Dim tempimage As imgdes
Dim bmh As BITMAPINFOHEADER
Dim fileType As String
    On Error Resume Next
    Screen.MousePointer = 11  ' Display the hourglass mouse pointer.
    
    getbmhfromimage bmh, vimage

    ' Initialize ftype
    rcode = BAD_FTPE
    ' Identify file type entered and save the image
    fileType = LCase$(right$(filename, 3))
    
    Select Case fileType
    
    Case "bmp"
        rcode = savebmp(filename, vimage, 0)
    Case "tif"
        rcode = savetif(filename, vimage, 0)
    Case "png"
        rcode = savepng(filename, vimage, 0)
    Case "jpg"
        If (bmh.biBitCount = 1) Then ' If we have a 1-bit image, convert to 8-bit grayscale
            ' because jpeg only supports 8-bit grayscale or 24-bit color images
            rcode = allocimage(tempimage, bmh.biWidth, bmh.biHeight, 8)
            If (rcode = NO_ERROR) Then
                rcode = convert1bitto8bit(vimage, tempimage)
                If (rcode = NO_ERROR) Then
                    rcode = savejpg(filename, tempimage, 75) ' Save 8-bit version of original image
                    freeimage tempimage  ' Release 8-bit version of original image
                End If
            End If
        
        Else
            'rcode = savejpg(filename, vimage, 75) ' Save original image
            If Dep_Fattore_Compressione_JPG% = 0 Then
                Dep_Fattore_Compressione_JPG% = 75
            End If
            rcode = savejpg(filename, vimage, Dep_Fattore_Compressione_JPG%) ' Save original image
        End If
    
    Case "gif"
        If (bmh.biBitCount = 24) Then ' If we have a 24-bit image, convert to 8-bit palette color
           ' because gif only supports up to 8-bit pixel depth
           
            Dim colors As Long
            Dim reduction_mode As Long
            
            rcode = allocimage(tempimage, bmh.biWidth, bmh.biHeight, 8)
            If (rcode = NO_ERROR) Then
                colors = 256
                reduction_mode = CR_TSDDIFF   ' For the best image quality
                rcode = convertrgbtopalex(colors, vimage, tempimage, reduction_mode)
                If (rcode = NO_ERROR) Then
                    rcode = savegif(filename, tempimage) ' Save 8-bit version of original image
                End If
                freeimage tempimage  ' Release 8-bit version of original image
            End If
            
        Else
           rcode = savegif(filename, vimage) ' Save original image
        End If
    
    End Select
    
    Screen.MousePointer = 0   ' Reset the mouse pointer.
    
    ' Handle any errors
    If rcode <> NO_ERROR Then
        'frmRidimensiona_Img.error_handler rcode, filename
        error_handler rcode, filename
    End If
End Sub


