Attribute VB_Name = "Module2"
Global vimage As imgdes

Type GUID
         Data1 As Long
         Data2 As Integer
         Data3 As Integer
         Data4(7) As Byte
End Type


Type PicBmp
            Size As Long
            Type As Long
            hBmp As Long
            hPal As Long
            Reserved As Long
End Type

Declare Function GetClipboardData Lib "user32" (ByVal wFormat As Long) As Long
Declare Function SetClipboardData Lib "user32" (ByVal wFormat As Long, ByVal hmem As Long) As Long
Declare Function EmptyClipboard Lib "user32" () As Long
Declare Function OpenClipboard Lib "user32" (ByVal hwnd As Long) As Long
Declare Function CloseClipboard Lib "user32" () As Long
Declare Function GlobalFree Lib "kernel32" (ByVal hmem As Long) As Long
Declare Function GlobalLock Lib "kernel32" (ByVal hmem As Long) As Long
Declare Function GlobalUnlock Lib "kernel32" (ByVal hmem As Long) As Long
Declare Function GlobalHandle Lib "kernel32" (ByVal Addr As Long) As Long
Declare Function GlobalHandlevalue Lib "kernel32" Alias "GlobalHandle" (ByVal Addr As Long) As Long
Declare Function OleCreatePictureIndirect Lib "olepro32.dll" (PicDesc As PicBmp, RefIID As GUID, ByVal fPictureOwnsHandle As Long, IPic As IPicture) As Long
Declare Sub RtlMoveMemory Lib "kernel32" (ByVal des As Long, ByVal src As Long, ByVal cnt As Long)
Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (des As Any, ByVal src As Long, ByVal cnt As Long)
Declare Sub CopyPaletteFromRGBArraytoImage Lib "kernel32" Alias "RtlMoveMemory" (ByVal paletteaddress As Long, ByRef srcarrayelement As RGBQUAD, ByVal cnt As Long)


' Open the file
Public Sub OpenFile(filename As String)

Dim bdata As BITMAPINFOHEADER
Dim gdata As GifData
Dim jdata As JpegData
Dim tdata As TiffData
Dim pdata As PngData
Dim rcode As Long, j As Long, ftype As Long
Dim width As Long, length As Long, vbitcount As Long
Dim fileType As String
Dim newimage As imgdes
Dim tempimage As imgdes
Dim key As Long
Dim xres As Long
Dim yres As Long
Dim resunit As Long

    key = 1234567  ' Not the real key. Real key requires lzw license from Unisys

    On Error Resume Next
    Screen.MousePointer = 11   ' Change mouse pointer to hourglass

    ' Initialize variables
    rcode = BAD_FTPE
    ftype = 0
    ' Identify file type and get information about the file to load
    fileType = LCase$(right$(filename, 3))
    
    Select Case fileType
        
        Case "bmp"
            rcode = bmpinfo(filename, bdata)
            width = bdata.biWidth
            length = bdata.biHeight
            vbitcount = bdata.biBitCount
            
            rcode = allocimage(tempimage, width, length, vbitcount)
            If (rcode = NO_ERROR) Then
                rcode = loadbmp(filename, tempimage)
            End If
            
        Case "gif"
            unlockLZW (key)
            rcode = gifinfo(filename, gdata)
            width = gdata.width
            length = gdata.length
            vbitcount = gdata.vbitcount
                            
            rcode = allocimage(tempimage, width, length, vbitcount)
            If (rcode = NO_ERROR) Then
                rcode = loadgif(filename, tempimage)
            End If
            
        Case "jpg"
            rcode = jpeginfo(filename, jdata)
            width = jdata.width
            length = jdata.length
            vbitcount = jdata.vbitcount
            
            rcode = allocimage(tempimage, width, length, vbitcount)
            If (rcode = NO_ERROR) Then
                rcode = loadjpg(filename, tempimage)
            End If
        
        Case "png"
            rcode = pnginfo(filename, pdata)
            width = pdata.width
            length = pdata.length
            vbitcount = pdata.vbitcount
        
            rcode = allocimage(tempimage, width, length, vbitcount)
            If (rcode = NO_ERROR) Then
                rcode = loadpng(filename, tempimage)
            End If
        
        Case "tif"
            Dim totalpages As Long
            Dim arrayelems As Long
            Dim pageIndex As Long
                     
            ftype = 3
            rcode = tiffgetpageinfo(filename, totalpages, 0, arrayelems)
            pageIndex = 0   ' get info about the first page
        
            rcode = tiffinfopagebyindex(filename, tdata, pageIndex)
            rcode = tiffgetxyresolutionpagebyindex(filename, xres, yres, resunit, pageIndex)
            width = tdata.width
            length = tdata.length
            vbitcount = tdata.vbitcount
    
            rcode = allocimage(tempimage, width, length, vbitcount)
            If (rcode = NO_ERROR) Then
                rcode = loadtifpagebyindex(filename, tempimage, pageIndex)
                
                ' 16-bit grayscale
                If rcode = NO_ERROR And tdata.BitsPSample = 16 And tdata.SamplesPPixel = 1 Then
                   rcode = allocimage(newimage, width, length, 8)
                   rcode = convertgray16to8(tempimage, newimage)
                   freeimage tempimage
                   copyimgdes newimage, tempimage
                End If
            End If
    End Select
            
    If rcode = NO_ERROR Then
        
        ' Replace previous image
        freeimage vimage
        copyimgdes tempimage, vimage
        
        ' Display the new image
        frmRidimensiona_Img.Picture1 = image_to_picturebox(vimage)
        frmRidimensiona_Img.Picture1.Refresh

    End If
    
    Screen.MousePointer = 0   ' Reset the mouse pointer.

    ' Handle any errors
    If rcode <> NO_ERROR Then
        'frmRidimensiona_Img.error_handler rcode, filename
        error_handler rcode, filename
    End If
End Sub

' Error handler for various functions. Errors are listed in GLOBALS.BAS.
'
' The first character in each string is "1" if the error message needs
' the file name appended to it, otherwise the first character is "0"
Sub error_handler(ByVal errcode As Long, filname As String)
Dim szErrstr As String

   If errcode <> NO_ERROR Then  'Ignore an error code of NO_ERROR
      ' Load error string into szErrstr
      Select Case errcode
         Case NO_ERROR
            szErrstr = "0"
         Case BAD_RANGE
            szErrstr = "0Value(s) out of range"
         Case NO_DIG
            szErrstr = "0Error in receiving image"
         Case BAD_DSK
            szErrstr = "1Disk full, file not written: "
         Case BAD_OPN
            szErrstr = "1Cannot open "
         Case BAD_FAC
            szErrstr = "0Invalid Data"
         Case BAD_TIFF
            szErrstr = "1Unreadable TIF format: "
         Case BAD_BPS
            szErrstr = "0Unsupported TIF bits per sample"
         Case BAD_CMP
            szErrstr = "0Unsupported compression scheme"
         Case BAD_CRT
            szErrstr = "1Cannot create "
         Case BAD_FTPE
            szErrstr = "1Invalid filetype: "
         Case BAD_DIB
            szErrstr = "0DIB is compressed and can not be processed"
         Case VMODE_ERR
            szErrstr = "0Invalid video mode"
         Case BAD_MEM
            szErrstr = "0Insufficient memory"
         Case BAD_PCX
            szErrstr = "1Unreadable PCX format: "
         Case BAD_GIF
            szErrstr = "1Unreadable GIF format: "
         Case PRT_ERR
            szErrstr = "0Printer error"
         Case SCAN_ERR
            szErrstr = "0Scanner error"
         Case BAD_TGA
            szErrstr = "1Unreadable Targa format: "
         Case BAD_BPP
            szErrstr = "0Image bits per pixel not supported by function"
         Case BAD_BMP
            szErrstr = "1Unreadable BMP format: "
         Case NO_DEV_DATA
            szErrstr = "0No data from device"
         Case TIMEOUT
            szErrstr = "0Function timed out"
         Case PRT_BUSY
            szErrstr = "0Print function is busy"
         Case BAD_IBUF
            szErrstr = "0Invalid image buffer address"
         Case TIFF_NOPAGE
            szErrstr = "0TIF page not found"
         Case TOO_CPLX
            szErrstr = "0Image is too complex to complete operation"
         Case NOT_AVAIL
            szErrstr = "0Function not available due to missing module"
         ' Scanner ADF error codes
         Case SCAN_UNLOAD
            szErrstr = "0Paper could not be unloaded from ADF"
         Case SCAN_LIDUP
            szErrstr = "0ADF lid was opened"
         Case SCAN_NOPAPER
            szErrstr = "0ADF bin is empty"
         Case SCAN_NOADF
            szErrstr = "0ADF is not connected"
         Case SCAN_NOTREADY
            szErrstr = "0ADF is connected but not ready"
         Case Else   'Set any invalid error codes to default
            szErrstr = "0Error encountered"
         End Select
      If left$(szErrstr, 1) <> "0" Then ' Additional args to print
         szErrstr = szErrstr + filname   ' Add append filename to error string
      End If
      ' Skip character code
      szErrstr = right(szErrstr, Len(szErrstr) - 1)
      MsgBox szErrstr, 16, "Error encountered!"
   End If
End Sub
